name: Build AppImage
run-name: ${{ gitea.actor }} is building THE AppImage 🚀
on: [push]

jobs:
  Explore-Gitea-Actions:
    runs-on: bullseye
    steps:
      - run: echo "🎉 The job was automatically triggered by a ${{ gitea.event_name }} event."
      - run: echo "🐧 This job is now running on a ${{ runner.os }} server hosted by Gitea!"
      - run: echo "🔎 The name of your branch is ${{ gitea.ref }} and your repository is ${{ gitea.repository }}."
      - name: Check out repository code
        uses: actions/checkout@v3
      - run: echo "💡 The ${{ gitea.repository }} repository has been cloned to the runner."
      - run: echo "🖥️ The workflow is now ready to test your code on the runner."
      - run: |
          apt-get -y update
          apt-get -y install python3-yaml python3-requests bash
      - name: Declare some variables
        shell: bash
        run: |
          ls -l
          echo "SHA_SHORT=$(git rev-parse --short HEAD)" >> "$GITEA_ENV"
          echo "YEAR=$(python3 -c \"import datetime;print(datetime.date.today().year)\")" >> "$GITEA_ENV"
          env
      - name: Build AppImage
        run: |
          eval $(gpg-agent --daemon --allow-preset-passphrase --default-cache-ttl 1 --max-cache-ttl 7200)
          /usr/lib/gnupg/gpg-preset-passphrase --preset --passphrase ${GPG_PASSPHRASE} ${GPG_KEYGRIP}
          ./tools/update_version.py
          ./tools/build.sh
        env:
          GPG_KEYGRIP: ${{ vars.GPG_KEYGRIP }}
          GPG_PASSPHRASE: ${{ secrets.GPG_PASSPHRASE }}
          GO_PIPELINE_LABEL: ${{ env.YEAR }}.${{ gitea.run_number }}_${{ env.SHA_SHORT }}
      - name: Upload AppImage
        run: ./tools/upload_gitea.sh
        env:
          GO_PIPELINE_LABEL: ${{ env.YEAR }}.${{ gitea.run_number }}_${{ env.SHA_SHORT }}
          UPLOAD_TOKEN: ${{ secrets.GITEA_TOKEN }}
          UPLOAD_USER: ${{ vars.GITEA_USER }}
      - run: echo "🍏 This job's status is ${{ job.status }}."
